base-compat-0.9.2: A compatibility layer for base

Safe Haskell | Safe
Language | Haskell98

Data.IORef.Compat

Synopsis

- modifyIORef' :: IORef a -> (a -> a) -> IO ()
- atomicModifyIORef' :: IORef a -> (a -> (a, b)) -> IO b
- atomicWriteIORef :: IORef a -> a -> IO ()

# Documentation

modifyIORef' :: IORef a -> (a -> a) -> IO () #

Strict version of `modifyIORef`

Since: 4.6.0.0

atomicModifyIORef' :: IORef a -> (a -> (a, b)) -> IO b #

Strict version of `atomicModifyIORef`. This forces both the value stored in the `IORef` as well as the value returned.

Since: 4.6.0.0

atomicWriteIORef :: IORef a -> a -> IO () #

Variant of `writeIORef` with the "barrier to reordering" property that `atomicModifyIORef` has.

Since: 4.6.0.0